package com.fr.plugin.it.config.simple.account;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "流程接口配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.fr.plugin.it.config.simple", text = "流程接口配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "start", name = "启动流程接口", description = "StartWorkflow", status = Status.SHOW)
    private Conf<String> start = Holders.simple("http://URI/service.asmx/StartWorkflow");

    @Identifier(value = "return1", name = "驳回工作任务接口", description = "ReturnWorkItem", status = Status.SHOW)
    private Conf<String> return1 = Holders.simple("http://URI/service.asmx/ReturnWorkItem");

    @Identifier(value = "returnToStart", name = "驳回工作任务到开始接口", description = "ReturnWorkflowToStart", status = Status.SHOW)
    private Conf<String> returnToStart = Holders.simple("http://URI/service.asmx/ReturnWorkflowToStart");

    @Identifier(value = "submit", name = "提交工作任务接口", description = "SubmitWorkItem", status = Status.SHOW)
    private Conf<String> submit = Holders.simple("http://URI/service.asmx/SubmitWorkItem");

    @Identifier(value = "cancel", name = "批量取消流程接口", description = "CancelInstances", status = Status.SHOW)
    private Conf<String> cancel = Holders.simple("http://URI/service.asmx/CancelInstances");

    @Identifier(value = "cancelWithRemark", name = "取消流程接口", description = "CancelInstanceWithRemark", status = Status.SHOW)
    private Conf<String> cancelWithRemark = Holders.simple("http://URI/service.asmx/CancelInstanceWithRemark");

    @Identifier(value = "restart", name = "重新激活流程接口", description = "ReStartWorkflow", status = Status.SHOW)
    private Conf<String> restart = Holders.simple("http://URI/service.asmx/ReStartWorkflow");

    @Identifier(value = "org", name = "获取岗位角色接口", description = "organization", status = Status.SHOW)
    private Conf<String> org = Holders.simple("http://URI/service.asmx?op=GetPostByUserCode");

    public String getCancelWithRemark() {
        return cancelWithRemark.get();
    }

    public void setCancelWithRemark(String url) {
        this.cancelWithRemark.set(url);
    }

    public String getReStart() {
        return restart.get();
    }

    public void setReStart(String url) {
        this.restart.set(url);
    }

    public String getStart() {
        return start.get();
    }

    public void setStart(String url) {
        this.start.set(url);
    }

    public String getReturn1() {
        return return1.get();
    }

    public void setReturn1(String url) {
        this.return1.set(url);
    }

    public String getReturnToStart() {
        return returnToStart.get();
    }

    public void setReturnToStart(String url) {
        this.returnToStart.set(url);
    }

    public String getSubmit() {
        return submit.get();
    }

    public void setSubmit(String url) {
        this.submit.set(url);
    }

    public String getCancel() {
        return cancel.get();
    }

    public void setCancel(String url) {
        this.cancel.set(url);
    }

    public String getOrg() {
        return org.get();
    }

    public void setOrg(String url) {
        this.org.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
